﻿// ECMAScript 5 strict mode
"use strict";

assert2(cr, "cr namespace not created");
assert2(cr.plugins_, "cr.plugins_ not created");

/////////////////////////////////////
// Plugin class
cr.plugins_.ppstudio_fsm = function(runtime)
{
	this.runtime = runtime;
};

(function ()
{
	var pluginProto = cr.plugins_.ppstudio_fsm.prototype;
		
	/////////////////////////////////////
	// Object type class
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};

	var typeProto = pluginProto.Type.prototype;
	
	/////////////////////////////////////
	// Instance class
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};

	typeProto.onCreate = function()
	{
	};	
	
	var instanceProto = pluginProto.Instance.prototype;
	
	instanceProto.onCreate = function()
	{
		// Read properties set in C3
		this._state = "";
		this._prevstate = "";
		this._instance = this;
		this._stateFinished ="";
	};
		
	instanceProto.saveToJSON = function ()
	{
		return {};
	};
	
	instanceProto.loadFromJSON = function (o)
	{
	};
	
	/**BEGIN-PREVIEWONLY**/
	instanceProto.getDebuggerValues = function (propsections)
	{
		let values = {
				title:"FSM Plugin",
				properties:[
					{name: "Current State", value:this._state},
					{name: "Previous State", value: this._prevstate}
				]
			};
		
		propsections[propsections.length]=values;
		
		return propsections;
	};
	/**END-PREVIEWONLY**/

	//////////////////////////////////////
	// Conditions
	function Cnds() {};
	
	Cnds.prototype.OnStateChanged = function (st)
	{
		if (st===this._state)
			return true;
	};

	Cnds.prototype.OnStateFinished = function (st){
		if (st===this._stateFinished)
				return true;
	}
	
	Cnds.prototype.CurrentState = function(st){
		if (st===this._state)
				return true;
	}
	
	Cnds.prototype.PreviousState = function(st){
		if (st===this._prevstate)
				return true;
	}
	
	Cnds.prototype.OnAnyStateChanged = function(){
		return true;
	}
	
	pluginProto.cnds = new Cnds();

	//////////////////////////////////////
	// Actions
	function Acts() {};

	Acts.prototype.ChangeState = function(state)
	{
		this._stateFinished = this._state;
		this._prevstate = this._state;
		this._state = state;
		this.runtime.trigger(cr.plugins_.ppstudio_fsm.prototype.cnds.OnStateFinished,this);
		this.runtime.trigger(cr.plugins_.ppstudio_fsm.prototype.cnds.OnAnyStateChanged,this);
		this.runtime.trigger(cr.plugins_.ppstudio_fsm.prototype.cnds.OnStateChanged,this);
	};
	
	pluginProto.acts = new Acts();

	//////////////////////////////////////
	// Expressions
	function Exps() {};
	
	Exps.prototype.GetState = function (ret)
	{
		ret.set_string(this._state);
	};
	
	Exps.prototype.GetPrevState = function (ret)
	{
		ret.set_string(this._prevstate);
	};
	
	pluginProto.exps = new Exps();

}());